diff -rNci gcc-2.7.2/config/i386/i386.h gcc-2.7.2p/config/i386/i386.h
*** gcc-2.7.2/config/i386/i386.h	Fri Sep 22 22:42:57 1995
--- gcc-2.7.2p/config/i386/i386.h	Tue Jan 23 10:31:11 1996
***************
*** 1146,1180 ****
     After reload, it makes no difference, since pseudo regs have
     been eliminated by then.  */
  
  
! /* Non strict versions, pseudos are ok */
! #define REG_OK_FOR_INDEX_NONSTRICT_P(X)					\
!   (REGNO (X) < STACK_POINTER_REGNUM					\
!    || REGNO (X) >= FIRST_PSEUDO_REGISTER)
  
! #define REG_OK_FOR_BASE_NONSTRICT_P(X)					\
!   (REGNO (X) <= STACK_POINTER_REGNUM					\
!    || REGNO (X) == ARG_POINTER_REGNUM					\
     || REGNO (X) >= FIRST_PSEUDO_REGISTER)
  
! #define REG_OK_FOR_STRREG_NONSTRICT_P(X)				\
    (REGNO (X) == 4 || REGNO (X) == 5 || REGNO (X) >= FIRST_PSEUDO_REGISTER)
  
! /* Strict versions, hard registers only */
! #define REG_OK_FOR_INDEX_STRICT_P(X) REGNO_OK_FOR_INDEX_P (REGNO (X))
! #define REG_OK_FOR_BASE_STRICT_P(X)  REGNO_OK_FOR_BASE_P (REGNO (X))
! #define REG_OK_FOR_STRREG_STRICT_P(X)					\
!   (REGNO_OK_FOR_DIREG_P (REGNO (X)) || REGNO_OK_FOR_SIREG_P (REGNO (X)))
  
! #ifndef REG_OK_STRICT
! #define REG_OK_FOR_INDEX_P(X)  REG_OK_FOR_INDEX_NONSTRICT_P(X)
! #define REG_OK_FOR_BASE_P(X)   REG_OK_FOR_BASE_NONSTRICT_P(X)
! #define REG_OK_FOR_STRREG_P(X) REG_OK_FOR_STRREG_NONSTRICT_P(X)
  
- #else
- #define REG_OK_FOR_INDEX_P(X)  REG_OK_FOR_INDEX_STRICT_P(X)
- #define REG_OK_FOR_BASE_P(X)   REG_OK_FOR_BASE_STRICT_P(X)
- #define REG_OK_FOR_STRREG_P(X) REG_OK_FOR_STRREG_STRICT_P(X)
  #endif
  
  /* GO_IF_LEGITIMATE_ADDRESS recognizes an RTL expression
--- 1072,1107 ----
     After reload, it makes no difference, since pseudo regs have
     been eliminated by then.  */
  
+ #ifndef REG_OK_STRICT
  
! /* Nonzero if X is a hard reg that can be used as an index or if
!    it is a pseudo reg.  */
  
! #define REG_OK_FOR_INDEX_P(X) \
!   (REGNO (X) < STACK_POINTER_REGNUM \
     || REGNO (X) >= FIRST_PSEUDO_REGISTER)
  
! /* Nonzero if X is a hard reg that can be used as a base reg
!    of if it is a pseudo reg.  */
!   /* ?wfs */
! 
! #define REG_OK_FOR_BASE_P(X) \
!   (REGNO (X) <= STACK_POINTER_REGNUM \
!    || REGNO (X) == ARG_POINTER_REGNUM \
!    || REGNO(X) >= FIRST_PSEUDO_REGISTER)
! 
! #define REG_OK_FOR_STRREG_P(X) \
    (REGNO (X) == 4 || REGNO (X) == 5 || REGNO (X) >= FIRST_PSEUDO_REGISTER)
  
! #else
  
! /* Nonzero if X is a hard reg that can be used as an index.  */
! #define REG_OK_FOR_INDEX_P(X) REGNO_OK_FOR_INDEX_P (REGNO (X))
! /* Nonzero if X is a hard reg that can be used as a base reg.  */
! #define REG_OK_FOR_BASE_P(X) REGNO_OK_FOR_BASE_P (REGNO (X))
! #define REG_OK_FOR_STRREG_P(X) \
!   (REGNO_OK_FOR_DIREG_P (REGNO (X)) || REGNO_OK_FOR_SIREG_P (REGNO (X)))
  
  #endif
  
  /* GO_IF_LEGITIMATE_ADDRESS recognizes an RTL expression
***************
*** 1200,1221 ****
  
  #define LEGITIMATE_CONSTANT_P(X) 1
  
! #ifdef REG_OK_STRICT
! #define GO_IF_LEGITIMATE_ADDRESS(MODE, X, ADDR)				\
! {									\
!   if (legitimate_address_p (MODE, X, 1))				\
!     goto ADDR;								\
! }
  
! #else
! #define GO_IF_LEGITIMATE_ADDRESS(MODE, X, ADDR)				\
  {									\
!   if (legitimate_address_p (MODE, X, 0))				\
      goto ADDR;								\
  }
  
- #endif
- 
  /* Try machine-dependent ways of modifying an illegitimate address
     to be legitimate.  If we find one, return the new, valid address.
     This macro is used in only one place: `memory_address' in explow.c.
--- 1127,1188 ----
  
  #define LEGITIMATE_CONSTANT_P(X) 1
  
! #define GO_IF_INDEXABLE_BASE(X, ADDR)	\
!  if (GET_CODE (X) == REG && REG_OK_FOR_BASE_P (X)) goto ADDR
  
! #define LEGITIMATE_INDEX_REG_P(X)   \
!   (GET_CODE (X) == REG && REG_OK_FOR_INDEX_P (X))
! 
! /* Return 1 if X is an index or an index times a scale.  */
! 
! #define LEGITIMATE_INDEX_P(X)   \
!    (LEGITIMATE_INDEX_REG_P (X)				\
!     || (GET_CODE (X) == MULT				\
! 	&& LEGITIMATE_INDEX_REG_P (XEXP (X, 0))		\
! 	&& GET_CODE (XEXP (X, 1)) == CONST_INT		\
! 	&& (INTVAL (XEXP (X, 1)) == 2			\
! 	    || INTVAL (XEXP (X, 1)) == 4		\
! 	    || INTVAL (XEXP (X, 1)) == 8)))
! 
! /* Go to ADDR if X is an index term, a base reg, or a sum of those.  */
! 
! #define GO_IF_INDEXING(X, ADDR)	\
! { if (LEGITIMATE_INDEX_P (X)) goto ADDR;				\
!   GO_IF_INDEXABLE_BASE (X, ADDR);					\
!   if (GET_CODE (X) == PLUS && LEGITIMATE_INDEX_P (XEXP (X, 0)))		\
!     { GO_IF_INDEXABLE_BASE (XEXP (X, 1), ADDR); }			\
!   if (GET_CODE (X) == PLUS && LEGITIMATE_INDEX_P (XEXP (X, 1)))		\
!     { GO_IF_INDEXABLE_BASE (XEXP (X, 0), ADDR); } }
! 
! /* We used to allow this, but it isn't ever used.
!    || ((GET_CODE (X) == POST_DEC || GET_CODE (X) == POST_INC)		\
!        && REG_P (XEXP (X, 0))						\
!        && REG_OK_FOR_STRREG_P (XEXP (X, 0)))				\
! */
! 
! #define GO_IF_LEGITIMATE_ADDRESS(MODE, X, ADDR)	\
  {									\
!   if (CONSTANT_ADDRESS_P (X)						\
!       && (! flag_pic || LEGITIMATE_PIC_OPERAND_P (X)))			\
      goto ADDR;								\
+   GO_IF_INDEXING (X, ADDR);						\
+   if (GET_CODE (X) == PLUS && CONSTANT_ADDRESS_P (XEXP (X, 1)))		\
+     {									\
+       rtx x0 = XEXP (X, 0);						\
+       if (! flag_pic || ! SYMBOLIC_CONST (XEXP (X, 1)))			\
+ 	{ GO_IF_INDEXING (x0, ADDR); }					\
+       else if (x0 == pic_offset_table_rtx)				\
+ 	goto ADDR;							\
+       else if (GET_CODE (x0) == PLUS)					\
+ 	{								\
+ 	  if (XEXP (x0, 0) == pic_offset_table_rtx)			\
+ 	    { GO_IF_INDEXABLE_BASE (XEXP (x0, 1), ADDR); }		\
+ 	  if (XEXP (x0, 1) == pic_offset_table_rtx)			\
+ 	    { GO_IF_INDEXABLE_BASE (XEXP (x0, 0), ADDR); }		\
+ 	}								\
+     }									\
  }
  
  /* Try machine-dependent ways of modifying an illegitimate address
     to be legitimate.  If we find one, return the new, valid address.
     This macro is used in only one place: `memory_address' in explow.c.
***************
*** 1237,1249 ****
     When -fpic is used, special handling is needed for symbolic references.
     See comments by legitimize_pic_address in i386.c for details.  */
  
! #define LEGITIMIZE_ADDRESS(X, OLDX, MODE, WIN)				\
! {									\
!   rtx orig_x = (X);							\
!   (X) = legitimize_address (X, OLDX, MODE);				\
!   if (memory_address_p (MODE, X))					\
!     goto WIN;								\
! }
  
  /* Nonzero if the constant value X is a legitimate general operand
     when generating PIC code.  It is given that flag_pic is on and 
--- 1204,1244 ----
     When -fpic is used, special handling is needed for symbolic references.
     See comments by legitimize_pic_address in i386.c for details.  */
  
! #define LEGITIMIZE_ADDRESS(X,OLDX,MODE,WIN)   \
! { extern rtx legitimize_pic_address ();					\
!   int ch = (X) != (OLDX);						\
!   if (flag_pic && SYMBOLIC_CONST (X))					\
!     {									\
!       (X) = legitimize_pic_address (X, 0);				\
!       if (memory_address_p (MODE, X))					\
! 	goto WIN;							\
!     }									\
!   if (GET_CODE (X) == PLUS)						\
!     { if (GET_CODE (XEXP (X, 0)) == MULT)				\
! 	ch = 1, XEXP (X, 0) = force_operand (XEXP (X, 0), 0);		\
!       if (GET_CODE (XEXP (X, 1)) == MULT)				\
! 	ch = 1, XEXP (X, 1) = force_operand (XEXP (X, 1), 0);		\
!       if (ch && GET_CODE (XEXP (X, 1)) == REG				\
! 	  && GET_CODE (XEXP (X, 0)) == REG)				\
! 	goto WIN;							\
!       if (flag_pic && SYMBOLIC_CONST (XEXP (X, 1)))			\
!         ch = 1, (X) = legitimize_pic_address (X, 0);			\
!       if (ch) { GO_IF_LEGITIMATE_ADDRESS (MODE, X, WIN); }		\
!       if (GET_CODE (XEXP (X, 0)) == REG)                                \
! 	{ register rtx temp = gen_reg_rtx (Pmode);			\
! 	  register rtx val = force_operand (XEXP (X, 1), temp);		\
! 	  if (val != temp) emit_move_insn (temp, val);			\
! 	  XEXP (X, 1) = temp;						\
! 	  goto WIN; }							\
!       else if (GET_CODE (XEXP (X, 1)) == REG)				\
! 	{ register rtx temp = gen_reg_rtx (Pmode);			\
! 	  register rtx val = force_operand (XEXP (X, 0), temp);		\
! 	  if (val != temp) emit_move_insn (temp, val);			\
! 	  XEXP (X, 0) = temp;						\
! 	  goto WIN; }}}
! 
! /* intel1 */
! #define REWRITE_ADDRESS(x) rewrite_address(x)
  
  /* Nonzero if the constant value X is a legitimate general operand
     when generating PIC code.  It is given that flag_pic is on and 
***************
*** 1381,1386 ****
--- 1376,1385 ----
  /* Nonzero if access to memory by bytes is slow and undesirable.  */
  #define SLOW_BYTE_ACCESS 0
  
+ /* intel1 */
+ /* Nonzero if access to memory by shorts is slow and undesirable.  */
+ #define SLOW_SHORT_ACCESS 1
+ 
  /* Define if shifts truncate the shift count
     which implies one can omit a sign-extension or zero-extension
     of a shift count.  */
***************
*** 1512,1517 ****
--- 1511,1517 ----
     stored from the compare operation.  Note that we can't use "rtx" here
     since it hasn't been defined!  */
  
+ extern struct rtx_def *i386_compare_op0, *i386_compare_op1;
  extern struct rtx_def *(*i386_compare_gen)(), *(*i386_compare_gen_eq)();
  
  /* Tell final.c how to eliminate redundant test instructions.  */
***************
*** 1519,1524 ****
--- 1519,1528 ----
  /* Here we define machine-dependent flags and fields in cc_status
     (see `conditions.h').  */
  
+ /* intel1 Set if the cc value is was actually from the 80387 and
+    we are testing eax directly (i.e. no sahf) */
+ #define CC_TEST_AX 020000
+ 
  /* Set if the cc value is actually in the 80387, so a floating point
     conditional branch must be output.  */
  #define CC_IN_80387 04000
***************
*** 1816,1827 ****
  	 { fputs ("argp", FILE); break; }		\
         if (STACK_TOP_P (X))				\
  	 { fputs ("st(0)", FILE); break; }		\
-        if (FP_REG_P (X))				\
- 	 { fputs (hi_name[REGNO(X)], FILE); break; }	\
         switch (GET_MODE_SIZE (GET_MODE (X)))		\
  	 {						\
! 	 default:					\
! 	   fputs ("e", FILE);				\
  	 case 2:					\
  	   fputs (hi_name[REGNO (X)], FILE);		\
  	   break;					\
--- 1820,1831 ----
  	 { fputs ("argp", FILE); break; }		\
         if (STACK_TOP_P (X))				\
  	 { fputs ("st(0)", FILE); break; }		\
         switch (GET_MODE_SIZE (GET_MODE (X)))		\
  	 {						\
! 	 case 12:					\
! 	 case 8:					\
! 	 case 4:					\
! 	   if (! FP_REG_P (X)) fputs ("e", FILE);	\
  	 case 2:					\
  	   fputs (hi_name[REGNO (X)], FILE);		\
  	   break;					\
***************
*** 1857,1865 ****
  #define RET return ""
  #define AT_SP(mode) (gen_rtx (MEM, (mode), stack_pointer_rtx))
  
- /* Functions in i386.c */
- extern void override_options ();
- extern void order_regs_for_local_alloc ();
  extern int i386_valid_decl_attribute_p ();
  extern int i386_valid_type_attribute_p ();
  extern int i386_return_pops_args ();
--- 1861,1866 ----
***************
*** 1868,1909 ****
  extern void function_arg_advance ();
  extern struct rtx_def *function_arg ();
  extern int function_arg_partial_nregs ();
- extern void output_op_from_reg ();
- extern void output_to_reg ();
- extern char *singlemove_string ();
- extern char *output_move_double ();
- extern char *output_move_memory ();
- extern char *output_move_pushmem ();
- extern int standard_80387_constant_p ();
- extern char *output_move_const_single ();
- extern int symbolic_operand ();
- extern int call_insn_operand ();
- extern int expander_call_insn_operand ();
- extern int symbolic_reference_mentioned_p ();
- extern void emit_pic_move ();
- extern void function_prologue ();
- extern int simple_386_epilogue ();
- extern void function_epilogue ();
- extern int legitimate_address_p ();
- extern struct rtx_def *legitimize_pic_address ();
- extern struct rtx_def *legitimize_address ();
- extern void print_operand ();
- extern void print_operand_address ();
- extern void notice_update_cc ();
- extern void split_di ();
- extern int binary_387_op ();
- extern int shift_op ();
- extern int VOIDmode_compare_op ();
- extern char *output_387_binary_op ();
- extern char *output_fix_trunc ();
- extern char *output_float_compare ();
- extern char *output_fp_cc0_set ();
- extern void save_386_machine_status ();
- extern void restore_386_machine_status ();
- extern void clear_386_stack_locals ();
- extern struct rtx_def *assign_386_stack_local ();
  
! /* Variables in i386.c */
  extern char *i386_reg_alloc_order;		/* register allocation order */
  extern char *i386_regparm_string;		/* # registers to use to pass args */
  extern char *i386_align_loops_string;		/* power of two alignment for loops */
--- 1869,1876 ----
  extern void function_arg_advance ();
  extern struct rtx_def *function_arg ();
  extern int function_arg_partial_nregs ();
  
!   /* Variables in i386.c */
  extern char *i386_reg_alloc_order;		/* register allocation order */
  extern char *i386_regparm_string;		/* # registers to use to pass args */
  extern char *i386_align_loops_string;		/* power of two alignment for loops */
***************
*** 1913,1932 ****
  extern int i386_align_loops;			/* power of two alignment for loops */
  extern int i386_align_jumps;			/* power of two alignment for non-loop jumps */
  extern int i386_align_funcs;			/* power of two alignment for functions */
! extern char *hi_reg_name[];			/* names for 16 bit regs */
! extern char *qi_reg_name[];			/* names for 8 bit regs (low) */
! extern char *qi_high_reg_name[];		/* names for 8 bit regs (high) */
! extern enum reg_class regclass_map[];		/* smalled class containing REGNO */
! extern struct rtx_def *i386_compare_op0;	/* operand 0 for comparisons */
! extern struct rtx_def *i386_compare_op1;	/* operand 1 for comparisons */
! 
! /* External variables used */
! extern int optimize;			/* optimization level */
! extern int obey_regdecls;		/* TRUE if stupid register allocation */
! 
! /* External functions used */
! extern struct rtx_def *force_operand ();
! 
  /*
  Local variables:
  version-control: t
--- 1880,1888 ----
  extern int i386_align_loops;			/* power of two alignment for loops */
  extern int i386_align_jumps;			/* power of two alignment for non-loop jumps */
  extern int i386_align_funcs;			/* power of two alignment for functions */
! /*extern char *hi_reg_name[];			/* names for 16 bit regs */
! /*extern char *qi_reg_name[];			/* names for 8 bit regs (low) */
! /*extern char *qi_high_reg_name[];		/* names for 8 bit regs (high) */
  /*
  Local variables:
  version-control: t
diff -rNci gcc-2.7.2/cse.c gcc-2.7.2p/cse.c
*** gcc-2.7.2/cse.c	Sun Nov 26 19:47:05 1995
--- gcc-2.7.2p/cse.c	Tue Jan 23 09:53:20 1996
***************
*** 6136,6141 ****
--- 6136,6164 ----
        sets = (struct set *) alloca (sizeof (struct set));
        sets[0].rtl = x;
  
+ /* intel1 */
+ #ifdef STACK_REGS
+ #ifdef IS_STACK_MODE
+       if (IS_STACK_MODE (DFmode) && GET_CODE (SET_SRC (x)) == CONST_DOUBLE 
+          && GET_CODE (SET_DEST (x)) == REG)
+         {
+            /* not worthwhile to hold on stack */
+ 	  rtx tem = find_reg_note (insn, REG_EQUAL, 0);
+ 	  
+ 	  /* Record the actual constant value in a REG_EQUAL note, making
+ 	     a new one if one does not already exist.  */
+ 	  if (tem)
+ 	    XEXP (tem, 0) = SET_SRC(x);
+ 	  else
+ 	    REG_NOTES (insn) = gen_rtx (EXPR_LIST, REG_EQUAL,
+ 				        SET_SRC(x), REG_NOTES (insn));
+ 
+ 	  invalidate (SET_DEST (x), GET_MODE(x) );
+         }
+       else
+       
+ #endif
+ #endif
        /* Ignore SETs that are unconditional jumps.
  	 They never need cse processing, so this does not hurt.
  	 The reason is not efficiency but rather
***************
*** 6762,6767 ****
--- 6785,6816 ----
        if (dest == pc_rtx && src_const && GET_CODE (src_const) == LABEL_REF)
  	src_folded = src_const, src_folded_cost = -1;
  	  
+ #ifdef SAVE_ON_REGS
+       /* intel1 If src is of form  (reg1 OP const) and src_folded
+          is of form (reg2 OP const) and the costs are the same
+          and reg1 != reg2,
+          then bump up the cost of src_folded so that src will be
+          preferred.  The reason for this is that if reg2 is used
+          here it's life may be extended thereby increasing register
+          pressure and causing superfulous movs.  */
+       {
+         char * fmt;
+         if (src)
+           fmt = GET_RTX_FORMAT (GET_CODE (src));
+         if (src && src_folded && src_cost == src_folded_cost
+             && GET_CODE (src) == GET_CODE (src_folded) 
+             && GET_RTX_LENGTH (GET_CODE (src)) == 2
+             && fmt[0] == 'e' && fmt[1] == 'e'
+             && GET_CODE (XEXP (src, 0)) == REG
+             && GET_CODE (XEXP (src, 1)) == CONST_INT 
+             && GET_CODE (XEXP (src_folded, 0)) == REG
+             && GET_CODE (XEXP (src_folded, 1)) == CONST_INT 
+             && !rtx_equal_p (XEXP (src, 0), XEXP (src_folded, 0)))
+           {
+             src_folded_cost++;
+           }          
+       }
+ #endif
        /* Terminate loop when replacement made.  This must terminate since
           the current contents will be tested and will always be valid.  */
        while (1)
***************
*** 7205,7210 ****
--- 7254,7269 ----
  	    if (sets[i].src_elt == 0)
  	      {
  		register struct table_elt *elt;
+ 		/* intel1 */
+ 		int do_rehash=0;
+ 
+                 /* intel1 */
+ 		if(GET_CODE(src)==REG && 
+ 		   !REGNO_QTY_VALID_P (REGNO(src)))
+ 		    { /* we will want to rehash all expressions based of src since
+ 		         reg_qty[REGNO(src)] is about to change */
+ 		      do_rehash = 1;
+ 		    }
  
  		/* Note that these insert_regs calls cannot remove
  		   any of the src_elt's, because they would have failed to
diff -rNci gcc-2.7.2/expr.c gcc-2.7.2p/expr.c
*** gcc-2.7.2/expr.c	Sun Nov 26 16:18:07 1995
--- gcc-2.7.2p/expr.c	Tue Jan 23 09:53:21 1996
***************
*** 24,29 ****
--- 24,31 ----
  #include "rtl.h"
  #include "tree.h"
  #include "obstack.h"
+ /* intel1 */
+ #include "c-tree.h"
  #include "flags.h"
  #include "regs.h"
  #include "function.h"
***************
*** 8954,8959 ****
--- 8956,8967 ----
  	  && (i = floor_log2 (TREE_INT_CST_LOW (TREE_OPERAND (exp, 1)))) >= 0
  	  && (mode = mode_for_size (i + 1, MODE_INT, 0)) != BLKmode
  	  && (type = type_for_mode (mode, 1)) != 0
+       /* intel1 */
+       && !(SLOW_SHORT_ACCESS
+          && (type == short_unsigned_type_node
+              || type == short_integer_type_node
+              || type == intHI_type_node
+              || type == unsigned_intHI_type_node))
  	  && TYPE_PRECISION (type) < TYPE_PRECISION (TREE_TYPE (exp))
  	  && (cmp_optab->handlers[(int) TYPE_MODE (type)].insn_code
  	      != CODE_FOR_nothing))
***************
*** 9111,9116 ****
--- 9119,9130 ----
  	type = type_for_size (bitsize, unsignedp);
  	if (! SLOW_BYTE_ACCESS
  	    && type != 0 && bitsize >= 0
+ 	    /* intel1 */
+ 	    && !(SLOW_SHORT_ACCESS 
+ 	         && (type == short_unsigned_type_node 
+ 	             || type == short_integer_type_node
+ 	             || type == intHI_type_node 
+ 	             || type == unsigned_intHI_type_node))
  	    && TYPE_PRECISION (type) < TYPE_PRECISION (TREE_TYPE (exp))
  	    && (cmp_optab->handlers[(int) TYPE_MODE (type)].insn_code
  		!= CODE_FOR_nothing))
diff -rNci gcc-2.7.2/flags.h gcc-2.7.2p/flags.h
*** gcc-2.7.2/flags.h	Thu Jun 15 11:34:11 1995
--- gcc-2.7.2p/flags.h	Tue Jan 23 09:25:25 1996
***************
*** 361,363 ****
--- 361,509 ----
     function.  */
  
  extern int current_function_has_nonlocal_goto;
+ 
+ /* intel1 our optimization controllers */
+ 
+ /* Optimize usage of registers for memory addresses */
+ 
+ extern int flag_opt_reg_use;
+ 
+ /* Do reduce all the mem address givs */
+ 
+ extern int flag_all_mem_givs;
+ 
+ /* Try to treat index terms of addresses as reducible mem givs */
+ 
+ extern int flag_reduce_index_givs;
+ 
+ /* After reload try to replace spill slots with equivalent registers */
+ 
+ extern int flag_peep_spills;
+ 
+ /* After reload try to optimize usage of spill slots in loops */
+ 
+ extern int flag_loop_after_global;
+ 
+ /* In optimization of loops treats jumps backwards as not nullifying
+    optimization opportunities.  */
+    
+ extern int flag_jump_back;
+ 
+ /* Do loop copy propogation */
+ 
+ extern int flag_copy_prop;
+ 
+ /* Do compare elimination */
+ 
+ extern int flag_compare_elim;
+ 
+ /* Do a mini software pipelining on stack registers */
+ 
+ extern int flag_sftwr_pipe;
+ 
+ /* Try aggressive changing of jumps taken to jumps not taken */
+ 
+ extern int flag_opt_jumps_out;
+ 
+ /* Try to replace memory operands with equivalent registers in first
+    pass of loop optimize */
+    
+ extern int flag_replace_mem;
+ 
+ /* Try to replace memory operands with equivalent stack registers in first
+    pass of loop optimize */
+    
+ extern int flag_replace_stack_mem;
+ 
+ /* After reload if a register is marked dead at a copy into another
+    register - see if the other register can be used in the first place.
+    Thereby eleiminating the copy.  */
+    
+ extern int flag_reg_reg_copy_opt;
+ 
+ /* Move stack registers that will be compared for equality off, the
+    stack before the comparison.  */
+    
+ extern int flag_do_offload;
+ 
+ /* Optimize usage of stack registers from the stack */
+ 
+ extern int flag_opt_reg_stack;
+ 
+ /* cse is sometimes detrimental - see flow.c */
+ 
+ extern int flag_correct_cse_mistakes;
+ 
+ /* Try to push loads back into loops if the loaded register has been spilled */
+ 
+ extern int flag_push_load_into_loop;
+ 
+ /* After reload use available registers to load memory operands into
+   them and use the register instead of the memory operand.  */
+   
+ extern int flag_risc;
+ 
+ /* After reload use available registers to load CONST_INTs into
+   them and then store the register instead of the CONST_INT.  */
+   
+ extern int flag_risc_const;
+ 
+ /* Allow scheduler to try to swap two instructions when the
+    first increments a register by a constant and the second
+    uses that register as a base
+ */
+ 
+ extern int flag_swap_for_agi;
+ 
+ /* A destination that was riscified should stay that way.  */
+ 
+ extern int flag_risc_mem_dest;
+ 
+ /* Try to use available registers so that a memory operand that is
+    reloaded will be reloaded into the same register.  This helps
+    loop_after_global.  */
+    
+ extern int flag_replace_reload_regs;
+ 
+ /* If the riscified instruction has not changed it's place in
+   scheduling then recombine it into a cisc instruction.  */
+   
+ extern int flag_recombine;
+ 
+ /* These negative flags needed to override optimization
+    levels which turn them on by default */
+    
+ extern int flag_no_omit_frame_pointer;
+ extern int flag_no_risc;
+ extern int flag_no_risc_const;
+ extern int flag_no_risc_mem_dest;
+ extern int flag_no_recombine;
+ /* Use the first pass of the scheduler to rearrange between
+    insns that reference stack registers.  */
+    
+ extern int flag_schedule_stack_reg_insns;
+ 
+ /* Use the first pass of the scheduler to rearrange between
+    insns that reference stack registers and those that don't
+    but not amongst themselves  */
+    
+ extern int flag_interleave_stack_non_stack;
+ 
+ /* These negative flags needed to override optimization
+    levels which turn them on by default */
+    
+ extern int flag_no_schedule_stack_reg_insns;
+ extern int flag_no_interleave_stack_non_stack;
+ 
+ extern int flag_sign_extension_elim;
+ 
+ /* Try to lift memory disambiguated memory operands that are stored
+    to in a loop into a register for the duration of the loop.  */
+    
+ extern int flag_lift_stores;
+ 
+ /* As above but do the disambiguation at runtime. i.e. there
+    will be two copies of the loop, one disambiguated one not,
+    And the decision of which one to run will be made at runtime.  */
+    
+ extern int flag_runtime_lift_stores;
